package Logica;
import java.io.Serializable;
import java.util.Vector;

public class Gestion implements Serializable{
	private Vector<Transaccion> gestiones;
	private float suma;
	private  float total;
	private boolean isPositivo;
	private String nombre;
	
	public Gestion(String nombre, boolean isPositivo) {
		this.gestiones = new Vector<Transaccion>();
		this.suma = 0;
		this.total = 0;
		this.nombre = nombre;
		this.isPositivo = isPositivo;
	}
	
	public String getNombre() {
		return this.nombre;
	}
	
	public void aniadirGasto(Transaccion transaccion) {
		this.gestiones.add(transaccion);
		this.suma += transaccion.getDinero();
		if(this.isPositivo) {
			this.total += transaccion.getDinero();
		}else {
			this.total -= transaccion.getDinero();
		}
	}
	
	public float getSuma() {
		return this.suma;
	}
	
	public float getTotal() {
		return this.total;
	}
	
	public Vector<Transaccion> getElementos(){
		return this.gestiones;
	}
	
	public void eliminarTransaccion(String transaccion) {
		for(Transaccion elemento:this.gestiones) {
			if(elemento.toString().equals(transaccion)) {
				this.gestiones.remove(elemento);
				return;
			}
		}
	}
	
	public boolean esIngreso() {
		return this.isPositivo;
	}
	
	public void alterarVisibilidad(int elemento) {
		if(this.gestiones.get(elemento).alterarVisivilidad()) {
			this.suma += this.gestiones.get(elemento).getDinero();
			if(this.isPositivo) {
				this.total += this.gestiones.get(elemento).getDinero();
			}else {
				this.total -= this.gestiones.get(elemento).getDinero();
			}
		}else {
			this.suma -= this.gestiones.get(elemento).getDinero();
			if(this.isPositivo) {
				this.total -= this.gestiones.get(elemento).getDinero();
			}else {
				this.total += this.gestiones.get(elemento).getDinero();
			}
		}
	}
	
	public String toString() {
		String ret = "";
		ret += this.nombre + " " + this.suma + " " + this.isPositivo;
		return ret;
	}

}
